/***************************************************************************/
/**                                                                       **/
/**              MODULAR-4 library for SPB module M-DA2-2                 **/
/**                                                                       **/
/**                             Version 2.B.                              **/
/**                                                                       **/
/**             Last change      : 25.11.1996                             **/
/**		Adaptation to Windows 95, Windows NT and OS/2 		  **/
/**                                                                       **/
/**                             Version 2.A.                              **/
/**                                                                       **/
/**  This file contains routines for Borland C++/3.1 to allow the user,   **/
/**  to write programs for the MODULAR-4 in "C" 			  **/
/**                                                                       **/
/**             Last change      : 10.05.1995                             **/
/**                                                                       **/
/**                         Author : H.K.                                 **/
/**                         Status : O.K.   			          **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/** This library was tested with Borland C++ Version 3.1.	          **/
/**                                                                       **/
/** No parameters are checked.						  **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**               (c) SORCUS Computer GmbH 1995                           **/
/**                                                                       **/
/***************************************************************************/

/* The switches for the library are set in the configuration files of Pascal
   (*.TP file) and C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*/

#include "m008_lib.h"

/* Static Arrays */

		 STATIC short m008gain[ANZ_MOD] [4];
		 STATIC short m008offset[ANZ_MOD] [4];
		 STATIC short m008soll[ANZ_MOD] [4];
		 STATIC short m008reset[ANZ_MOD] [4];
		 STATIC short m008range[ANZ_MOD] [4];

#if defined (__DLL__) && !defined (__OS2__)/* if a module DLL shall be generated */

#include <windows.h>

HANDLE   hInst;

#pragma argsused

int far pascal LibMain(hInstance, wDataSeg, wHeapSize, lpszCmdLine)
HANDLE  hInstance;                /* Instance of DLL          */
WORD    wDataSeg;                 /* Data segment             */
WORD    wHeapSize;                /* Size of Heap  	      */
LPSTR   lpszCmdLine;              /* Pointer to command line  */

{

  hInst = hInstance;

  if (wHeapSize > 0) UnlockData(0);

  return(1);
}

#endif  /* __DLL__ */


/* Correct output values with corgain and coroffset */

void correction(short corgain, short coroffset, short *data_var)
{
 short i1,lowi1,highi1;

  /* How to calculate:

    *data_var = (*data_var + coroffset) * (1 + corgain / 4096)        */

 i1 = *data_var + coroffset;                 /* Assign value to a variable and
						add offset */
 lowi1 = i1 % 256;                           /* Calculate low value */
 highi1 = i1 / 256;                          /* Calculate high value */
 lowi1 = (lowi1 * corgain) >> 12;            /* Low value * corgain div 4096 */
 highi1 = (highi1 * corgain) >> 4;           /* High value * corgain div 16 */
 *data_var = i1 + lowi1 + highi1;            /* Returm sum */
}

/* Correct Over/Underflow of value */

void overflow(short min, short max, short *data_var)
{
 if (*data_var < min) *data_var = min; /* Value below: *data_var = mininum */
 if (*data_var > max) *data_var = max; /* Value above: *data_var = maxinum */
}

/* Init module library
*/
MLXAPI void EXPORT m008_bib_startup (void)
{
 ushort w;
 short m,endm;
 byte ch;

  if (lobyte(mlx_read_eeprom(1,0)) == 0x29)    /* Check, whether module extender or not */
    endm = ANZ_MOD;                            /* Max. number of slots */
  else
    endm = 5;                                  /* 4 slots */
  for (m=1;m < endm;m++) {                     /* Check all slots, */
    if (lobyte(mlx_read_eeprom(m,0)) == 0x08) {/* whether M-DA2-2 module */
      w = mlx_read_eeprom(m,7);                /* Read gain and offset of channel 0 */
      m008gain[m] [0] = (char) (w >> 8);
      m008offset[m] [0] = (char) w;
      w = mlx_read_eeprom(m,5);                /* Start value after reset of channel 0 */
      m008reset[m] [0] = (short) w;
      m008soll[m] [0] = (short) w;
      w = mlx_read_eeprom(m,8);                /* Read gain and offset of channel 1 */
      m008gain[m] [1] = (char) (w >> 8);
      m008offset[m] [1] = (char) w;
      w = mlx_read_eeprom(m,6);                /* Start value after reset of channel 1 */
      m008reset[m] [1] = (short) w;
      m008soll[m] [1] = (short) w;
      w = mlx_read_eeprom(m,3);                /* Read jumper configuration */
      if ((w & 0x0040) == 0x0040)              /* B4: Pin 5 connected to 6: bipolar */
	m008range[m] [0] = 1;
      else
	m008range[m] [0] = 0;                  /* unipolar */
      w = mlx_read_eeprom(m,4);                /* Read jumper configuration */
      if ((w & 0x0040) == 0x0040)              /* B3: Pin 5 connected to 6: bipolar */
	m008range[m] [1] = 1;
      else
	m008range[m] [1] = 0;                  /* unipolar */
      }
      else {
	for (ch=0;ch < 2;ch++) {
	  m008gain[m] [ch] = 0;                /* Gain channel ch */
	  m008offset[m] [ch] = 0;              /* Offset channel ch */
	  m008reset[m] [ch] = 0;               /* Start value channel ch */
	  m008soll[m] [ch] = 0;
	  }
	}
    }
}

/* Set correction values
*/
MLXAPI void EXPORT m008_set_correct_values (byte micro_slot, byte channel, short corgain, short coroffset)
{
 m008gain[micro_slot] [channel] = corgain;           /* Correction value of gain */
 m008offset[micro_slot] [channel] = coroffset;       /* Correction value of offset */
}

/* Read correction values
*/
MLXAPI void EXPORT m008_get_correct_values (byte micro_slot, byte channel, short *corgain, short *coroffset)
{
 *corgain = m008gain[micro_slot] [channel];          /* Correction value of gain */
 *coroffset = m008offset[micro_slot] [channel];      /* Correction value of offset */
}

/* Correct output value
*/
MLXAPI void EXPORT m008_correct (byte micro_slot, byte channel, short *data_var)
{
  if ((m008gain[micro_slot] [channel] != 0)          /* Correction valuee of gain and offset <> 0 ? */
    || (m008offset[micro_slot] [channel] != 0)) {
    if (m008range[micro_slot] [channel]  == 1) {     /* Output range: bipolar */
      correction(m008gain[micro_slot] [channel],
		 m008offset[micro_slot] [channel],data_var);    /* Correct */
      overflow(-2048,2047,data_var);                 /* and cut, if neccessary */
    }
    else {                                           /* Output range: unipolar */
      correction(m008gain[micro_slot] [channel],
		 m008offset[micro_slot] [channel],data_var);     /* Correct */
      overflow(0,4095,data_var);                     /* and cut, if necessary */
    }
  }
}

/* Output to D/A-channel
*/
MLXAPI void EXPORT m008_out(byte micro_slot, byte channel, byte flag, short data_var)
{

  if (m008range[micro_slot] [channel] == 1)          /* Output range: bipolar           */
    data_var = data_var + 2048;
  if (flag == 1)
    m008_correct(micro_slot,channel,&data_var);
  m008soll[micro_slot] [channel] = data_var;         /* Store value */
  mlx_out_port(MBASIS+M008_CODE_CH_0+(channel*4),lobyte(data_var) >> 4);       /* Write to D/A-channel */
  mlx_out_port(MBASIS+M008_CODE_CH_0+(channel*4)+1,lobyte(data_var) >> 4);
  mlx_out_port(MBASIS+M008_CODE_CH_0+(channel*4)+1,lobyte(data_var) >> 4);
  mlx_out_port(MBASIS+M008_CODE_CH_0+(channel*4)+2,lobyte(data_var));
  mlx_out_port(MBASIS+M008_CODE_CH_0+(channel*4)+2,lobyte(data_var));
  mlx_out_port(MBASIS+M008_CODE_CH_0+(channel*4)+3,hibyte(data_var));
  mlx_out_port(MBASIS+M008_CODE_CH_0+(channel*4)+3,hibyte(data_var));
  mlx_out_port(MBASIS+M008_CODE_CH_0+(channel*4)+3,hibyte(data_var));
  mlx_out_port(MBASIS+M008_CODE_CH_0+(channel*4)+3,hibyte(data_var));
  mlx_out_port(MBASIS+M008_CODE_CH_0+(channel*4)+4,hibyte(data_var));
}

/* Read stored value of D/A-channel
*/
MLXAPI void EXPORT m008_get_setvalue(byte micro_slot, byte channel, short *datbyte)
{
  *datbyte = m008soll[micro_slot] [channel];
}

/* Init module like EEPROM
*/
MLXAPI void EXPORT m008_set_conf_eeprom(byte micro_slot)
{
  short data_var;
  byte ch;

  for (ch=0;ch < 2;ch++) {
    data_var = m008reset[micro_slot] [ch];              /* Load output value of channel ch */
    m008_correct(micro_slot,ch,&data_var);              /* Correct and cut, if necessary */
    m008_out(micro_slot,ch,0,m008reset[micro_slot] [ch]); /* Output value to D/A-channel */
    }
}


