#ifndef _m008_lib_
#define _m008_lib_
/***************************************************************************/
/**                                                                       **/
/**              MODULAR-4 library for SPB module M-DA2-2                 **/
/**                                                                       **/
/**                             Version 2.B.                              **/
/**                                                                       **/
/**             Last change      : 25.11.1996                             **/
/**				 Adaptation to Windows 95, Windows NT and OS/2 				  **/
/**                                                                       **/
/**                             Version 2.A.                              **/
/**                                                                       **/
/**  This file contains routines for Borland C++/3.1 to allow the user,   **/
/**  to write programs for the MODULAR-4 in "C" 			  **/
/**                                                                       **/
/**             Last change      : 10.05.1995                             **/
/**                                                                       **/
/**                         Author : H.K.                                 **/
/**                         Status : O.K.	    		          				  **/
/**                                                                       **/
/**                                                                       **/
/** Special comments: 							  										  **/
/**                                                                       **/
/** This library was tested with Borland C++ Version 3.1.	          	  **/
/**                                                                       **/
/** No parameters are checked.						  								  **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**               (c) SORCUS Computer GmbH 1995                           **/
/**                                                                       **/
/***************************************************************************/

/* The switches for the library are set in the configuration files of Pascal
	(*.TP file) and C (project-file). They can also be set in this source file:

	Then the following #defines have to exist:

	If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

	If the library shall be used as realtime library on the MODULAR-4/486
	#define ML8 and #define ML8RT have to be included (default is PC library).

	If you work with Windows, this is detected by the compiler. No #defines have
	to be included.
*/

#include <MODULE.H>

#define MBASIS               micro_slot_basis[micro_slot] /* Module base address */

/* Defines for MODULAR-4/486 boards */

#define MBASIS            micro_slot_basis[micro_slot] /* Module base address  */
#define M008_CODE_CH_0     0x0                         /* Load byte channel DA-0   */
#define M008_CODE_CH_1     0x4                         /* Load byte channel DA-1   */

#if defined(__cplusplus)
extern "C" {
#endif

/* Init module library
*/
MLXAPI void EXPORT m008_bib_startup (void);

/* Init module like EEPROM
*/
MLXAPI void EXPORT m008_set_conf_eeprom (byte micro_slot);

/* Set correction values
*/
MLXAPI void EXPORT m008_set_correct_values (byte micro_slot, byte channel, short corgain, short coroffset);

/* Read correction values
*/
MLXAPI void EXPORT m008_get_correct_values (byte micro_slot, byte channel, short *corgain, short *coroffset);

/* Correct output value
*/
MLXAPI void EXPORT m008_correct (byte micro_slot, byte channel, short *data_var);

/* Output value to D/A-channel
*/
MLXAPI void EXPORT m008_out (byte micro_slot, byte channel, byte flag, short data_var);

/* Read stored value of D/A-channel
*/
MLXAPI void EXPORT m008_get_setvalue (byte micro_slot, byte channel, short *datbyte);

#if defined(__cplusplus)
} /*  Block end of extern "C" */
#endif

#endif