{$C MOVEABLE DEMANDLOAD DISCARDABLE}
(***************************************************************************)
(**                                                                       **)
(**              MODULAR-4 library for SPB module M-DA2-2                 **)
(**                                                                       **)
(**                             Version 2.B.                              **)
(**                                                                       **)
(**             Last change      : 25.11.1996                             **)
(**             Adaptation to Windows 95, Windows NT and OS/2             **)
(**                                                                       **)
(**                             Version 2.A.                              **)
(**                                                                       **)
(**  This file contains routines for Borland Pascal to allow the user,    **)
(**  to write programs for the MODULAR-4 in "Pascal" 			  **)
(**                                                                       **)
(**             Last change      : 10.05.1995                             **)
(**                                                                       **)
(**                         Author : H.K.                                 **)
(**                         Status : O.K.  		                  **)
(**                                                                       **)
(**                                                                       **)
(** Special comments: 							  **)
(**                                                                       **)
(** This library was tested with Borland Pascal Version 7.0.	          **)
(**                                                                       **)
(** No parameters are checked.						  **)
(**                                                                       **)
(**                                                                       **)
(**                                                                       **)
(**               (c) SORCUS Computer GmbH 1995                           **)
(**                                                                       **)
(***************************************************************************)

(* The switches for the library are set in the configuration files of Pascal
   (*.TP file) and C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*)

unit m008_lib;
interface
uses
{$IFDEF ML8}
        {$IFDEF Windows}
                wml8bib;        (* Include library for MODULAR-4/486 under Windows *)
        {$ELSE}
               {$IFDEF ML8RT}
                       ml8rtbib;    (* Include library for MODULAR-4/486 realtime programs *)
               {$ELSE}
                       ml8bib;      (* Include library for MODULAR-4/486 under DOS *)
               {$ENDIF}
        {$ENDIF}
{$ELSE}
        {$IFDEF Windows}
                wml4bib,wml4deb;    (* Include library for MODULAR-4/Z80 under WINDOWS *)
        {$ELSE}
                ml4bib,ml4deb;      (* Include library for MODULAR-4/Z80 under DOS *)
        {$ENDIF}
{$ENDIF}

{$IFDEF Windows}
const
     M008DLL = 'M008_LIB';
{$ENDIF}

(* Init module library *)

procedure m008_bib_startup;

(* Init module like EEPROM *)

procedure m008_set_conf_eeprom(micro_slot: byte);

(* Set correction values *)

procedure m008_set_correct_values (micro_slot: byte; channel:byte; corgain, coroffset:integer);

(* Read Correction values *)

procedure m008_get_correct_values (micro_slot: byte; channel:byte; var corgain, coroffset:integer);

(* Correct output value *)

procedure m008_correct (micro_slot: byte; channel: byte; var data_var: integer);

(* Output value to D/A-channel *)

procedure m008_out(micro_slot: byte; channel: byte; flag: byte; datbyte: integer);

(* Read stored value of D/A-channel *)

procedure m008_get_setvalue (micro_slot: byte;channel: byte; var datbyte: integer);


implementation

{$IFNDEF Windows}   (* If no DLL is used, a .OBJ file has to be included *)

{$L m008_lib.obj}

{$ENDIF}


(* Init module library *)

procedure m008_bib_startup;
          external {$IFDEF Windows} M008DLL {$ENDIF};

(* Set correction values *)

procedure m008_set_correct_values(micro_slot: byte; channel:byte; corgain, coroffset:integer);
          external {$IFDEF Windows} M008DLL {$ENDIF};

(* Read correction values *)

procedure m008_get_correct_values (micro_slot: byte; channel:byte; var corgain, coroffset:integer);
          external {$IFDEF Windows} M008DLL {$ENDIF};

(* Inti module like EEPROM *)

procedure m008_set_conf_eeprom(micro_slot: byte);
          external {$IFDEF Windows} M008DLL {$ENDIF};

(* Correct output value *)

procedure m008_correct (micro_slot: byte; channel: byte; var data_var: integer);
          external {$IFDEF Windows} M008DLL {$ENDIF};

(* Output value to D/A-channel *)

procedure m008_out(micro_slot: byte; channel: byte; flag: byte; datbyte: integer);
          external {$IFDEF Windows} M008DLL {$ENDIF};

(* Read stored value of D/A-channel *)

procedure m008_get_setvalue (micro_slot: byte;channel: byte; var datbyte: integer);
          external {$IFDEF Windows} M008DLL {$ENDIF};

begin
end.